

"""
Description of the treasure chest logic puzzle
There are 4 treasure chests, labelled A,B,C,D.
There is gold in one chest.
Each chest has its own statement, for example "The gold is not in here."
Only one statement can be true, the other 3 statements false.
Where is the gold?
"""

def createTreasureChest(name, statement, statedLocation, state=False, goldInHere=False) :
    """ A definition(function) for a treasure chest .. each attribute is described:
        name is a string : either 'A', 'B','C,'D'
        statement is what is written on the chest
        statedLocation is where the treasure should be if the statement is true
        state is whether the statement is true or false
        goldInHere is true if the chest contains the gold (otherwise false)
    """
    trChest = {}
    trChest["name"] = name
    trChest["statement"] = statement
    trChest["statedLocation"] = statedLocation
    trChest["state"] = state
    trChest["goldInHere"] = goldInHere

    return trChest

# this method (function) below is simply to illustrate the descriptive power of functions
def place_gold_in_chest(trChest):
    trChest["goldInHere"] = True
    print('\nPlacing Gold in Chest ' + trChest["name"])


def check_for_solution(treasurelist):
    global trueStatement
    solutionFound = False
    numberOfTrues = 0    
    for i in range(len(treasurelist)):
        if (treasurelist[i]["state"]) :
            numberOfTrues += 1
            trueStatement = i
    if (numberOfTrues == 1) :   solutionFound = True
    return solutionFound

            
""" Initialise the problem to No Gold and all statements false """
A_treasurechest = createTreasureChest('A', 'The Gold is not in Here', ['B', 'C', 'D'])
B_treasurechest = createTreasureChest('B', 'The Gold is in Here', ['B'])
C_treasurechest = createTreasureChest('C', 'The Gold is B or D', ['B','D'])
D_treasurechest = createTreasureChest('D', 'The Gold is not in Here', ['A', 'B', 'C'])


trlist = [A_treasurechest, B_treasurechest, C_treasurechest, D_treasurechest]
for TC in trlist: print(TC["name"] + " : " + TC["statement"])


numberOfSolutions = 0

for i in range(len(trlist)) :
    place_gold_in_chest(trlist[i])
    trlist[i-1]["goldInHere"] = False  #remove gold from previous iteration
    #print('currentLocation ' + currentLocation)
    for j in range(len(trlist)) :
        trlist[j]["state"] = False
        if (trlist[i]["name"] in trlist[j]["statedLocation"]) : 
            trlist[j]["state"] = True
    if (check_for_solution(trlist)) :
            numberOfSolutions = numberOfSolutions + 1
            print('Solution Found ', ' Gold is in Chest ', trlist[i]["name"],
                                     ' True Statement is on Chest ', trlist[trueStatement]["name"])

print("\nNumber of Solution(s) Found : ", numberOfSolutions)




"""
A program to solve a logic puzzle using classes, and using trial and error,
and exhaistive scenarios.
See above for description of the puzzle.
"""





